﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.utils.getTimer;
	
	public class RandomDistributionDemo extends Sprite
	{
		private static const DEFAULT_COLOR:uint = 0xFFCCCCCC;
		private static const COLOR:uint = 0x00000000;
		private static const COLOR_AVERAGE:uint = 0xFFFF0000;
		private static const AVERAGE:uint = 0xFFFF00FF;
		private static const CHART_RECT:Rectangle = new Rectangle(0, 0, 256, 512);
		private var chart:BitmapData = new BitmapData(CHART_RECT.width, CHART_RECT.height, false, DEFAULT_COLOR);
		private var chartValues:Array = new Array(256);
		private static const RANDOM_FUNCTION:Array = [
			new RandomFunction(
				function():Number
				{
					return Math.random();
				},
				"Math.random();"
			),
			new RandomFunction(
				function():Number
				{
					return Math.random() * Math.random();
				},
				"Math.random() * Math.random();"
			),
			new RandomFunction(
				function():Number
				{
					var r:Number = Math.random();
					return r * r;
				},
				"r = Math.random(); r * r;"
			),
			new RandomFunction(
				function():Number
				{
					var r:Number = Math.random();
					return (3 - 2 * r) * r * r;
				},
				"r = Math.random(); (3 - 2 * r) * r * r;"
			),
			new RandomFunction(
				function():Number
				{
					return Math.sqrt(Math.random());
				},
				"Math.sqrt(Math.random());"
			),
			new RandomFunction(
				function():Number
				{
					return Math.max(Math.random(), Math.random());
				},
				"Math.max(Math.random(), Math.random());"
			),
			new RandomFunction(
				function():Number
				{
					return Math.max(Math.random(), Math.random(), Math.random());
				},
				"Math.max(Math.random(), Math.random(), Math.random());"
			),
			new RandomFunction(
				function():Number
				{
					return Math.max(Math.random(), Math.random(), Math.random(), Math.random());
				},
				"Math.max(Math.random(), Math.random(), Math.random(), Math.random());"
			),
			new RandomFunction(
				function():Number
				{
					return 0.02 * Math.floor(50 * Math.random());
				},
				"0.02 * Math.floor(50 * Math.random());"
			),
			new RandomFunction(
				function():Number
				{
					return 0.3 * Math.random() + 0.7 * Math.random();
				},
				"0.3 * Math.random() + 0.7 * Math.random();"
			),
			new RandomFunction(
				function():Number
				{
					return 0.02 * Math.floor(50 * Math.random());
				},
				"0.02 * Math.floor(50 * Math.random());"
			),
			new RandomFunction(
				function():Number
				{
					return 0.5 * (Math.random() + Math.random());
				},
				"0.5 * (Math.random() + Math.random());"
			),
			new RandomFunction(
				function():Number
				{
					return 0.333 * (Math.random() + Math.random() + Math.random());
				},
				"0.333 * (Math.random() + Math.random() + Math.random());"
			),
			new RandomFunction(
				function():Number
				{
					return 0.25 * (Math.random() + Math.random() + Math.random() + Math.random());
				},
				"0.25 * (Math.random() + Math.random() + Math.random() + Math.random());"
			),
			new RandomFunction(
				function():Number
				{
					var r:Number = Math.random() - Math.random() + Math.random() - Math.random();
					r += (r < 0.0) ? 4.0 : 0.0;
					return r *= 0.25;
				},
				"r = Math.random() - Math.random() + Math.random() - Math.random(); r += (r < 0.0) ? 4.0 : 0.0; r *= 0.25;"
			),
			new RandomFunction(
				function():Number
				{
					var r:Number = Math.random();
					return r > 0 ? Math.min(0.2 / r, 1) : 0;
				},
				"r = Math.random(); r > 0 ? Math.min(0.2 / r, 1) : 0;"
			),
			new RandomFunction(
				function():Number
				{
					var r:Number = Math.random();
					return (r > 0 ? Math.min(0.2 / r, 1) : 0) - 0.2;
				},
				"r = Math.random(); (r > 0 ? Math.min(0.2 / r, 1) : 0) - 0.2;"
			),
			new RandomFunction(
				function():Number
				{
					return 0.2 * Math.random() + 0.8 * Math.random() * Math.random();
				},
				"0.2 * Math.random() + 0.8 * Math.random() * Math.random()"
			),
			new RandomFunction(
				function():Number
				{
					return 0.5 * Math.random() + 0.5 * Math.random() * Math.random();
				},
				"0.5 * Math.random() + 0.5 * Math.random() * Math.random()"
			),
			new RandomFunction(
				function():Number
				{
					return 0.5 * Math.random() + 0.5 * Math.random() * Math.random();
				},
				"0.5 * Math.random() * Math.random() + 0.5 * Math.random() * Math.random()"
			),
			new RandomFunction(
				function():Number
				{
					return Math.max(Math.min(Math.random() - Math.random() * Math.random(), 1), 0);
				},
				"Math.max(Math.min(Math.random() - Math.random() * Math.random(), 1), 0);"
			)
		];
		private var currentFunction:uint = 0;
		private var average:Rectangle = new Rectangle(0, 0, CHART_RECT.width, 1);
		private var description:TextField = new TextField();
		
		public function RandomDistributionDemo():void
		{
			this.stage.scaleMode = StageScaleMode.NO_SCALE;
			this.stage.align = StageAlign.TOP_LEFT;
			
			this.addChild(new Bitmap(this.chart));
			this.description.defaultTextFormat = new TextFormat("CodingFontTobi", 16);
			this.description.width = 256;
			this.description.autoSize = TextFieldAutoSize.LEFT;
			this.description.embedFonts = true;
			this.description.multiline = true;
			this.description.wordWrap = true;
			this.addChild(this.description);
			
			this.redrawChart();
			
			this.stage.addEventListener(MouseEvent.CLICK, this.mouseUpHandler, false, 0, true);
		}
		
		private function mouseUpHandler(event:MouseEvent):void
		{
			if((this.currentFunction = ++ this.currentFunction) >= RANDOM_FUNCTION.length)
				this.currentFunction = 0;
			this.redrawChart();
		}
		
		private function redrawChart():void
		{
			var initialRedrawTime:uint = getTimer();
			//Errase
			this.chart.fillRect(CHART_RECT, DEFAULT_COLOR);
			
			var i:uint;
			for (i = 0; i < this.chartValues.length; i++)
				chartValues[i] = 0;
			
			var averageValue:Number = 0;
			var randomValue:Number;
			var randomFunction:RandomFunction = RANDOM_FUNCTION[this.currentFunction];
			var initialTime:uint = getTimer();
			for (i = 0; i < 1000000; i ++)
			{
				randomValue = randomFunction.random();
				averageValue += randomValue;
				this.chartValues[uint(randomValue * 255)]++;
			}
			var afterTime:uint = getTimer();
			averageValue = uint(averageValue / 1000000 * 255);
			
			var numAverage:uint;
			var height:uint = CHART_RECT.height;
			var fillRect:Rectangle = new Rectangle(0, 0, 1, 0);
			var numValue:uint;
			for (i = 0; i < this.chartValues.length; i++)
			{
				numValue = this.chartValues[i] / 50;
				numAverage += numValue;
				fillRect.x = i;
				fillRect.y = height - numValue;
				fillRect.height = numValue;
				this.chart.fillRect(fillRect, i == averageValue ? COLOR_AVERAGE : COLOR);
			}
			numAverage /= this.chartValues.length;
			
			this.average.y = height - numAverage;
			this.chart.fillRect(this.average, AVERAGE);
			
			
			this.description.text = "Generated in " + (getTimer() - initialRedrawTime) + " ms (" + (afterTime - initialTime) + " ms)\n"
			+ "Code:\n\t" + randomFunction.description + "\n\nClick to see the next";
		}
	}
}